<?php

namespace Pinpoint\SalesRep\Controller\Adminhtml\Savesalesrep;

use Magento\Backend\App\Action;
use Magento\Framework\Controller\Result\Json;
use Magento\Framework\Controller\Result\JsonFactory;
use Pinpoint\SalesRep\Block\Adminhtml\Order\View\Tab\SalesRep;
use Pinpoint\SalesRep\Plugin\AdminAddComment;

/**
 * Class Index
 */
class Index extends Action
{
    /**
     * @var JsonFactory
     */
    protected JsonFactory $jsonFactory;

    /**
     * @var AdminAddComment
     */
    protected AdminAddComment $addComment;

    /**
     * @var SalesRep
     */
    protected SalesRep $salesRep;

    /**
     * View constructor.
     * @param Action\Context $context
     * @param JsonFactory $jsonFactory
     * @param AdminAddComment $addComment
     * @param SalesRep $salesRep
     */
    public function __construct(
        JsonFactory $jsonFactory,
        AdminAddComment $addComment,
        SalesRep $salesRep,
        Action\Context $context
    ) {
        $this->addComment = $addComment;
        $this->jsonFactory = $jsonFactory;
        $this->salesRep = $salesRep;
        parent::__construct($context);
    }

    /**
     * Execute save index controller
     * @return Json
     * @inheritDoc
     * @throws \Exception
     */
    public function execute()
    {
        $data = $this->getRequest()->getParams();
        $this->addComment->assignSalesRep($data['order_id'], $data['user_id']);

        $return['success'] = true;
        $return['user_name'] = $this->salesRep->getSalesRepName($data['user_id']);
        $return['order_id'] = $data['order_id'];
        $return['user_id'] = $data['user_id'];

        return $this->jsonFactory->create()->setData($return);
    }
}
